//////////////////////////
#version 150
#pragma optimize(off)
#pragma debug(on)
#extension all : disable
//////////////////////////

// -- Uniform --

uniform sampler2D Tex_Grass;
uniform sampler2D Tex_GrassNoise;
uniform float farDist;

// -- Input fragment --

in vec2 fTexCoord;
flat in float dist;

// -- Output fragment --

out vec4 outColor;

void main()
{
   vec4 grassTex = texture(Tex_Grass,fTexCoord.xy);

   if(farDist > 0)
   {
     float grassTexAlpha = grassTex.a;
     float noise = texture(Tex_GrassNoise,fTexCoord.xy).r;
     float rDist = dist/farDist;

     grassTexAlpha = grassTexAlpha * noise;

     if(grassTexAlpha > rDist+0.1)
     { 
        outColor = vec4(grassTex.rgba);
     }
     else
     {
        discard;
     }
   }
   else
   {
      outColor = vec4(grassTex);
   }
}