//////////////////////////
#version 150
#pragma optimize(off)
#pragma debug(on)
#extension all : disable
//////////////////////////

// -- Uniform --


uniform mat4 Matrix_MVP;
uniform vec3 camRight;
uniform vec3 camUp;
uniform vec3 camPosition;

// -- Input vertex attributes --

in vec3 pos;
in vec4 sc2_tx2;

// -- Output vertex attributes --

out vec2 fTexCoord;
flat out float dist;


void main()
{
	//compute offset position
      vec3 newPos = pos + (camRight * sc2_tx2.x) + (camUp * sc2_tx2.y);
	
	//assign texcoord 
	fTexCoord = sc2_tx2.zw;

      //assign distance
      dist = distance(camPosition,newPos);
      	
	//write position
	gl_Position = Matrix_MVP * vec4(newPos,1.0);
}