
//////////////////////////
#version 150
#pragma optimize(on)
#pragma debug(off)
#extension all : disable
//////////////////////////


// -- Uniform --

uniform mat4 Matrix_M;
uniform mat4 Matrix_MV;
uniform mat4 Matrix_MVP;
uniform vec4 Clipping_Plane;

// -- Input vertex attributes --

in vec3 pos;
in vec2 tex0;
in vec3 normal;
in vec3 tangent;

// -- Output vertex attributes --

out vec4 fPosWorld;
out vec4 fPosView;
out vec2 fTexCoord0;
out vec3 fNormalWorld;
out vec3 fTangentWorld;


// -- Main --

void main()
{
	fPosWorld = Matrix_M * vec4(pos, 1);
	fPosView = Matrix_MV * vec4(pos, 1);
	fTexCoord0 = tex0;
	fNormalWorld = vec3(Matrix_M * vec4(normal, 0));
	fTangentWorld = vec3(Matrix_M * vec4(tangent, 0));
	
	gl_Position = Matrix_MVP * vec4(pos,1);
	gl_ClipDistance[0] = dot(fPosWorld.xyz, Clipping_Plane.xyz) + Clipping_Plane.w;
}