
//////////////////////////
#version 150
#pragma optimize(on)
#pragma debug(off)
#extension all : disable
//////////////////////////


// -- Uniform --
uniform mat4 Matrix_M;
uniform mat4 Matrix_MVP;
uniform vec4 ClippingPlane;


// -- Input vertex attributes --
in vec3 pos;
in vec2 tex0;
in vec3 normal;


// -- Output vertex attributes --
out vec2 fTex0;
out vec3 fNormal;
out vec4 fPosWorld;


// -- Main --
void main()
{
	fTex0 = tex0;
	fNormal = normal;
	gl_Position = Matrix_MVP * vec4(pos, 1);
	
	fPosWorld = Matrix_M * vec4(pos, 1);
	gl_ClipDistance[0] = dot(fPosWorld.xyz, ClippingPlane.xyz) + ClippingPlane.w;
}