
//////////////////////////
#version 150
#pragma optimize(on)
#pragma debug(off)
#extension all : disable
//////////////////////////


// -- Uniform --

// Light view projection matrix
uniform mat4 Matrix_MVP;
uniform float DeltaTime;


// -- Input vertex attributes --
in vec3 pos;
in vec2 tex0;


// -- Output vertex attributes --
out vec4 fProjCoord;
out vec2 fWaveTex0;
out vec2 fWaveTex1;
out vec2 fWaveTex2;
out vec2 fWaveTex3;


// -- Main --
void main()
{
	gl_Position = Matrix_MVP * vec4(pos, 1);
	
	fProjCoord = Matrix_MVP * vec4(pos, 1);
	
	// Generate water waves
	fWaveTex0.xy = tex0.xy + vec2(DeltaTime / 2, DeltaTime) * 3;
	fWaveTex1.xy = tex0.xy * 4 + vec2(DeltaTime / 2, DeltaTime) * 3;
	fWaveTex2.xy = tex0.xy * 8 + vec2(DeltaTime / 2, DeltaTime) * 3;
	fWaveTex3.xy = tex0.xy * 16 + vec2(DeltaTime /2, DeltaTime) * 3;
}